unit colorUnit;

{  colorform holds 3 arraybuttons for red, green,bleu
   tag = 0 : red, 1 : green, 2 : blue
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, davArrayBtn;

type
  Tcolorform = class(TForm)
    redbtn: TDavArrayBtn;
    greenbtn: TDavArrayBtn;
    bluebtn: TDavArrayBtn;
    PaintBox1: TPaintBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure PaintBox1Paint(Sender: TObject);
    procedure redbtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure redbtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure redbtnLeave(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  colorform: Tcolorform;

function selectcolor(var c : LongInt) : boolean;

implementation

uses Unit1;

{$R *.dfm}

const colorconversion : array[0..19] of byte =           //button nr to value
                         ($00,$20,$40,$60,$70,$80,$90,$a0,$a8,$b0,
                          $b8,$c0,$c8,$d0,$d8,$e0,$e8,$f0,$f8,$ff);
var cbtn : array[0..2] of byte = (0,0,0);  //color button nrs  r,g,b
    mixcolor : LongInt = $000000;  //final selected color
    tempcolor : longInt = $000000; //temprary color

function selectcolor(var c : LongInt) : boolean;
var x,y : integer;
begin
 with form1 do
  begin
   x := left + propBtn.left + propBtn.width + 20;
   y := top + propbtn.top + propbtn.btnheight;
  end;
 with colorform do
  begin
   left := x;
   top := y;
   ShowModal;
   result := modalresult = mrOK;
   if result then c := mixcolor;
  end;
end;

procedure Tcolorform.PaintBox1Paint(Sender: TObject);
//color the paintbox with tempcolor;
begin
 with paintbox1 do with canvas do
  begin
   pen.Width := 1;
   pen.Color := 0;
   brush.style := bssolid;
   brush.Color := tempcolor;
   rectangle(0,0,width,height);
  end;
end;

procedure Tcolorform.redbtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
//receive change event from all (r,g,b) coloor buttons
var a : array[0..2] of byte;
    i : byte;
begin
 with sender as TdavArrayBtn do
  if status = stDown then
   begin
    cbtn[tag] := BtnNr;
    tempcolor := 0;
    for i := 0 to 2 do
     begin
      a[i] := colorconversion[cbtn[i]];
      tempcolor := tempcolor or a[i] shl (8*i);
      mixcolor := tempcolor;
     end;
   end;
end;

procedure Tcolorform.redbtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
//recieve paint event from all (r,g,b) color buttons
var r : Trect;
    a : array[0..2] of byte;
    i : byte;
begin
 with sender as TdavArrayBtn do with canvas do
  begin
   r := getBtnRect(BtnNr);
   inc(r.Top,2);
   inc(r.Left,2);
   dec(r.Right,2);
   dec(r.bottom,2);
   brush.color := colorconversion[btnNr] shl (8*tag);
   brush.Style := bssolid;
   fillrect(r);
   if status = stHI then
    begin
     for i := 0 to 2 do a[i] := colorconversion[cbtn[i]];
     a[tag] := colorconversion[BtnNr];
     tempcolor := 0;
     for i := 0 to 2 do tempcolor := tempcolor or (a[i] shl (8*i));
     paintbox1.invalidate;
    end;
  end;
end;

procedure Tcolorform.redbtnLeave(Sender: TObject);
//receive onleave from all (r,g,b) arraybuttons
begin
 tempcolor := mixcolor;
 paintbox1.Invalidate;
end;

end.
